from http.server import HTTPServer, SimpleHTTPRequestHandler


PORT = 9000


class Handler(SimpleHTTPRequestHandler):

    def do_GET(self):
        self.send_response(200)
        self.end_headers()
        self.wfile.write(b'Hello World!\n')


    def do_POST(self):
        self.send_response(201)
        self.end_headers()
        self.wfile.write(b'Some resource created!\n')


def main():
    httpd = HTTPServer(('', PORT), Handler)
    print("serving at port", PORT)
    httpd.serve_forever()


if __name__ == '__main__':
    main()
